Require Import bool.
Require Import connectives.
Require Import logic.
Require Import nat.
Require Import relations.
Definition injn : (nat.nat -> nat.nat) -> nat.nat -> Prop := fun (f:(nat.nat -> nat.nat)) => fun (n:nat.nat) => forall (i:nat.nat), forall (j:nat.nat), (nat.le i n) -> (nat.le j n) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j.
Definition permut : (nat.nat -> nat.nat) -> nat.nat -> Prop := fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => connectives.And (forall (i:nat.nat), (nat.le i m) -> nat.le (f i) m) (injn f m).
Definition transpose : nat.nat -> nat.nat -> nat.nat -> nat.nat := fun (i:nat.nat) => fun (j:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) (nat.eqb n i).
Definition transpose_i_j_i : forall (i:nat.nat), forall (j:nat.nat), logic.eq (nat.nat) (transpose i j i) j := fun (i:nat.nat) => fun (j:nat.nat) => ((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i i (nat.eqb i j)) x) j)) ((((((bool.eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i i (nat.eqb i j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i i (nat.eqb i j)) bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i i (nat.eqb i j)) bool.true)))) (nat.eqb i i)) ((nat.eqb_n_n) (i)).
Definition transpose_i_j_j : forall (i:nat.nat), forall (j:nat.nat), logic.eq (nat.nat) (transpose i j j) i := fun (i:nat.nat) => fun (j:nat.nat) => ((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb j i) bool.true)) (logic.eq (bool.bool) (nat.eqb j i) bool.false)) (logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) (nat.eqb j i)) i)) (fun (Hc:logic.eq (bool.bool) (nat.eqb j i) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) x) i)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j (nat.eqb j j))) (fun (y:nat.nat) => logic.eq (nat.nat) y i)) (((((((logic.eq_ind_r) (nat.nat)) (i)) (fun (x:nat.nat) => logic.eq (nat.nat) x i)) (((logic.refl) (nat.nat)) (i))) (j)) ((((nat.eqb_true_to_eq) (j)) (i)) (Hc))))) (nat.eqb j i)) (Hc)))) (fun (Hc:logic.eq (bool.bool) (nat.eqb j i) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) x) i)) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j x) bool.false) i)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j bool.true)) (fun (y:nat.nat) => logic.eq (nat.nat) y i)) ((((((bool.eq_match_bool_type_true) (nat.nat)) (i)) (j)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) i j bool.true) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j bool.true)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) i j bool.true) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j bool.true)) (fun (y:nat.nat) => logic.eq (nat.nat) y (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j bool.true) bool.false))) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j bool.true) bool.false))))))) (nat.eqb j j)) ((nat.eqb_n_n) (j)))) (nat.eqb j i)) (Hc)))) ((bool.true_or_false) (nat.eqb j i)).
Definition transpose_transpose : forall (i:nat.nat), forall (j:nat.nat), forall (n:nat.nat), logic.eq (nat.nat) (transpose i j (transpose i j n)) n := fun (i:nat.nat) => fun (j:nat.nat) => fun (n:nat.nat) => ((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb n i) bool.true)) (logic.eq (bool.bool) (nat.eqb n i) bool.false)) (logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) (nat.eqb n i)) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) (nat.eqb n i)) j)) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) (nat.eqb n i)) i)) n)) (fun (Hni:logic.eq (bool.bool) (nat.eqb n i) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) j)) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.true) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.true) j)) (nat.eqb y i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.true) (nat.eqb y j)) (nat.eqb j i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i y (nat.eqb j j)) (nat.eqb j i)) n)) (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb j i) bool.true)) (logic.eq (bool.bool) (nat.eqb j i) bool.false)) (logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) (nat.eqb j i)) n)) (fun (Hji:logic.eq (bool.bool) (nat.eqb j i) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) x) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j (nat.eqb j j))) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((((((logic.eq_ind_r) (nat.nat)) (i)) (fun (x:nat.nat) => logic.eq (nat.nat) j x)) ((((nat.eqb_true_to_eq) (j)) (i)) (Hji))) (n)) ((((nat.eqb_true_to_eq) (n)) (i)) (Hni))))) (nat.eqb j i)) (Hji)))) (fun (Hji:logic.eq (bool.bool) (nat.eqb j i) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i j (nat.eqb j j)) x) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i j (nat.eqb j j))) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) i j x) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (i)) (j)) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((((logic.sym_eq) (nat.nat)) (n)) (i)) ((((nat.eqb_true_to_eq) (n)) (i)) (Hni))))) (nat.eqb j j)) ((nat.eqb_n_n) (j))))) (nat.eqb j i)) (Hji)))) ((bool.true_or_false) (nat.eqb j i))))))) (nat.eqb n i)) (Hni)))) (fun (Hni:logic.eq (bool.bool) (nat.eqb n i) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) j)) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.false) (nat.eqb (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.false) j)) (nat.eqb y i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) bool.false) (nat.eqb y j)) (nat.eqb (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n (nat.eqb n j))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i y (nat.eqb (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) j)) (nat.eqb (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) i)) n)) (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb n j) bool.true)) (logic.eq (bool.bool) (nat.eqb n j) bool.false)) (logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) (nat.eqb (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) j)) (nat.eqb (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) i)) n)) (fun (Hnj:logic.eq (bool.bool) (nat.eqb n j) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n x) (nat.eqb (bool.match_bool_type (nat.nat) i n x) j)) (nat.eqb (bool.match_bool_type (nat.nat) i n x) i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n bool.true) (nat.eqb (bool.match_bool_type (nat.nat) i n bool.true) j)) (nat.eqb y i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n bool.true) (nat.eqb y j)) (nat.eqb i i)) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i y (nat.eqb i j)) (nat.eqb i i)) n)) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i i (nat.eqb i j)) x) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i i (nat.eqb i j))) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((((logic.sym_eq) (nat.nat)) (n)) (j)) ((((nat.eqb_true_to_eq) (n)) (j)) (Hnj))))) (nat.eqb i i)) ((nat.eqb_n_n) (i))))))) (nat.eqb n j)) (Hnj)))) (fun (Hnj:logic.eq (bool.bool) (nat.eqb n j) bool.false) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n x) (nat.eqb (bool.match_bool_type (nat.nat) i n x) j)) (nat.eqb (bool.match_bool_type (nat.nat) i n x) i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n bool.false) (nat.eqb (bool.match_bool_type (nat.nat) i n bool.false) j)) (nat.eqb y i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i (bool.match_bool_type (nat.nat) i n bool.false) (nat.eqb y j)) (nat.eqb n i)) n)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i y (nat.eqb n j)) (nat.eqb n i)) n)) (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n (nat.eqb n j)) x) n)) (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n x) bool.false) n)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (i)) (n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n bool.false) bool.false) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i n bool.false)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n bool.false) bool.false) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i n bool.false) bool.false))))) (nat.eqb n j)) (Hnj))) (nat.eqb n i)) (Hni)))))) (nat.eqb n j)) (Hnj)))) ((bool.true_or_false) (nat.eqb n j))))))) (nat.eqb n i)) (Hni)))) ((bool.true_or_false) (nat.eqb n i)).
Definition injective_transpose : forall (i:nat.nat), forall (j:nat.nat), relations.injective (nat.nat) (nat.nat) (transpose i j) := fun (i:nat.nat) => fun (j:nat.nat) => fun (x:nat.nat) => fun (y:nat.nat) => fun (auto:logic.eq (nat.nat) (transpose i j x) (transpose i j y)) => (((((((logic.rewrite_r) (nat.nat)) (y)) (fun (__:nat.nat) => logic.eq (nat.nat) __ y)) (((logic.refl) (nat.nat)) (y))) (x)) (((((((logic.rewrite_l) (nat.nat)) (transpose i j (transpose i j x))) (fun (__:nat.nat) => logic.eq (nat.nat) __ y)) (((((((logic.rewrite_r) (nat.nat)) (transpose i j y)) (fun (__:nat.nat) => logic.eq (nat.nat) (transpose i j __) y)) ((((transpose_transpose) (i)) (j)) (y))) (transpose i j x)) (auto))) (x)) ((((transpose_transpose) (i)) (j)) (x)))).
Definition permut_S_to_permut_transpose : forall (f:(nat.nat -> nat.nat)), forall (m:nat.nat), (permut f (nat.S m)) -> permut (fun (n:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f n)) m := fun (f:nat.nat -> nat.nat) => fun (m:nat.nat) => fun (_clearme:permut f (nat.S m)) => ((((((connectives.match_And_prop) (forall (i:nat.nat), (nat.le i (nat.S m)) -> nat.le (f i) (nat.S m))) (injn f (nat.S m))) (permut (fun (n:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f n)) m)) (fun (permf1:forall (i:nat.nat), (nat.le i (nat.S m)) -> nat.le (f i) (nat.S m)) => (fun (permf2:injn f (nat.S m)) => (((((connectives.conj) (forall (x:nat.nat), (nat.le x m) -> nat.le (transpose (f (nat.S m)) (nat.S m) (f x)) m)) (injn (fun (n:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f n)) m)) (fun (i:nat.nat) => fun (leim:nat.le i m) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => nat.le (bool.match_bool_type (nat.nat) (nat.S m) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f i) (nat.eqb (f i) (nat.S m))) x) m)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (nat.S m)) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f i) (nat.eqb (f i) (nat.S m)))) (fun (y:nat.nat) => nat.le y m)) (((((((connectives.match_Or_prop) (nat.lt (f i) (nat.S m))) (logic.eq (nat.nat) (f i) (nat.S m))) (nat.le (bool.match_bool_type (nat.nat) (f (nat.S m)) (f i) (nat.eqb (f i) (nat.S m))) m)) (fun (Hfi:nat.lt (f i) (nat.S m)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => nat.le (bool.match_bool_type (nat.nat) (f (nat.S m)) (f i) x) m)) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (f (nat.S m))) (f i)) (fun (y:nat.nat) => nat.le y m)) ((((nat.le_S_S_to_le) (f i)) (m)) (Hfi)))) (nat.eqb (f i) (nat.S m))) ((((nat.not_eq_to_eqb_false) (f i)) (nat.S m)) ((((nat.lt_to_not_eq) (f i)) (nat.S m)) (Hfi)))))) (fun (Hfi:logic.eq (nat.nat) (f i) (nat.S m)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => nat.le (bool.match_bool_type (nat.nat) (f (nat.S m)) (f i) x) m)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (f (nat.S m))) (f i)) (fun (y:nat.nat) => nat.le y m)) (((((((connectives.match_Or_prop) (nat.lt (f (nat.S m)) (nat.S m))) (logic.eq (nat.nat) (f (nat.S m)) (nat.S m))) (nat.le (f (nat.S m)) m)) (fun (H:nat.lt (f (nat.S m)) (nat.S m)) => ((((nat.le_S_S_to_le) (f (nat.S m))) (m)) (H)))) (fun (H:logic.eq (nat.nat) (f (nat.S m)) (nat.S m)) => (((connectives.falsity) (nat.le (f (nat.S m)) m)) ((((logic.absurd) (logic.eq (nat.nat) i (nat.S m))) ((((((permf2) (i)) (nat.S m)) ((((nat.le_S) (i)) (m)) (leim))) ((nat.le_n) (nat.S m))) (((((((logic.rewrite_l) (nat.nat)) (f i)) (fun (__:nat.nat) => logic.eq (nat.nat) (f i) (f __))) (((((((logic.rewrite_r) (nat.nat)) (f i)) (fun (__:nat.nat) => logic.eq (nat.nat) (f i) __)) (((logic.refl) (nat.nat)) (f i))) (f (f i))) (((((((logic.rewrite_r) (nat.nat)) (nat.S m)) (fun (__:nat.nat) => logic.eq (nat.nat) (f (f i)) __)) (((((((logic.rewrite_r) (nat.nat)) (nat.S m)) (fun (__:nat.nat) => logic.eq (nat.nat) (f __) (nat.S m))) (H)) (f i)) (Hfi))) (f i)) (Hfi)))) (nat.S m)) (Hfi)))) (((((logic.not_to_not) (logic.eq (nat.nat) i (nat.S m))) (nat.le (nat.S m) m)) (fun (auto:logic.eq (nat.nat) i (nat.S m)) => (((((logic.eq_coerc) (nat.le i m)) (nat.le (nat.S m) m)) (leim)) (((((((logic.rewrite_l) (nat.nat)) (i)) (fun (__:nat.nat) => logic.eq (Prop) (nat.le i m) (nat.le __ m))) (((logic.refl) (Prop)) (nat.le i m))) (nat.S m)) (auto))))) ((((nat.lt_to_not_le) (m)) (nat.S m)) ((nat.le_n) (nat.S m)))))))) ((((nat.le_to_or_lt_eq) (f (nat.S m))) (nat.S m)) (((permf1) (nat.S m)) ((nat.le_n) (nat.S m))))))) (nat.eqb (f i) (nat.S m))) ((((nat.eq_to_eqb_true) (f i)) (nat.S m)) (Hfi))))) ((((nat.le_to_or_lt_eq) (f i)) (nat.S m)) (((permf1) (i)) ((((nat.le_S) (i)) (m)) (leim))))))) (nat.eqb (f i) (f (nat.S m)))) ((((nat.not_eq_to_eqb_false) (f i)) (f (nat.S m))) (((connectives.nmk) (logic.eq (nat.nat) (f i) (f (nat.S m)))) (fun (H:logic.eq (nat.nat) (f i) (f (nat.S m))) => ((((logic.absurd) (logic.eq (nat.nat) i (nat.S m))) ((((((permf2) (i)) (nat.S m)) ((((nat.le_S) (i)) (m)) (leim))) ((nat.le_n) (nat.S m))) (H))) ((((nat.lt_to_not_eq) (i)) (nat.S m)) ((((nat.le_S_S) (i)) (m)) (leim)))))))))) (fun (a:nat.nat) => fun (b:nat.nat) => fun (leam:nat.le a m) => (fun (lebm:nat.le b m) => (fun (H:logic.eq (nat.nat) (transpose (f (nat.S m)) (nat.S m) (f a)) (transpose (f (nat.S m)) (nat.S m) (f b))) => ((((((permf2) (a)) (b)) ((((nat.le_S) (a)) (m)) (leam))) ((((nat.le_S) (b)) (m)) (lebm))) ((((((injective_transpose) (f (nat.S m))) (nat.S m)) (f a)) (f b)) (H)))))))))) (_clearme)).
Definition bijn : (nat.nat -> nat.nat) -> nat.nat -> Prop := fun (f:(nat.nat -> nat.nat)) => fun (n:nat.nat) => forall (m:nat.nat), (nat.le m n) -> connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f p) m)).
Definition eq_to_bijn : forall (f:(nat.nat -> nat.nat)), forall (g:(nat.nat -> nat.nat)), forall (n:nat.nat), (forall (i:nat.nat), (nat.le i n) -> logic.eq (nat.nat) (f i) (g i)) -> (bijn f n) -> bijn g n := fun (f:nat.nat -> nat.nat) => fun (g:nat.nat -> nat.nat) => fun (n:nat.nat) => fun (H:forall (i:nat.nat), (nat.le i n) -> logic.eq (nat.nat) (f i) (g i)) => (fun (bijf:bijn f n) => (fun (i:nat.nat) => fun (lein:nat.le i n) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f p) i))) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (g p) i)))) (fun (a:nat.nat) => fun (_clearme:connectives.And (nat.le a n) (logic.eq (nat.nat) (f a) i)) => ((((((connectives.match_And_prop) (nat.le a n)) (logic.eq (nat.nat) (f a) i)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (g p) i)))) (fun (lean:nat.le a n) => (fun (fa:logic.eq (nat.nat) (f a) i) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x n) (logic.eq (nat.nat) (g x) i))) (a)) (((((connectives.conj) (nat.le a n)) (logic.eq (nat.nat) (g a) i)) (lean)) (((((((logic.eq_ind) (nat.nat)) (f a)) (fun (x_1:nat.nat) => logic.eq (nat.nat) (g a) x_1)) (((((logic.sym_eq) (nat.nat)) (f a)) (g a)) (((H) (a)) (lean)))) (i)) (fa))))))) (_clearme)))) (((bijf) (i)) (lein))))).
Definition bijn_n_Sn : forall (f:(nat.nat -> nat.nat)), forall (n:nat.nat), (bijn f n) -> (logic.eq (nat.nat) (f (nat.S n)) (nat.S n)) -> bijn f (nat.S n) := fun (f:nat.nat -> nat.nat) => fun (n:nat.nat) => fun (bijf:bijn f n) => (fun (fS:logic.eq (nat.nat) (f (nat.S n)) (nat.S n)) => (fun (i:nat.nat) => fun (lein:nat.le i (nat.S n)) => (((((((connectives.match_Or_prop) (nat.lt i (nat.S n))) (logic.eq (nat.nat) i (nat.S n))) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p (nat.S n)) (logic.eq (nat.nat) (f p) i)))) (fun (Hi:nat.lt i (nat.S n)) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f p) i))) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p (nat.S n)) (logic.eq (nat.nat) (f p) i)))) (fun (a:nat.nat) => fun (_clearme:connectives.And (nat.le a n) (logic.eq (nat.nat) (f a) i)) => ((((((connectives.match_And_prop) (nat.le a n)) (logic.eq (nat.nat) (f a) i)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p (nat.S n)) (logic.eq (nat.nat) (f p) i)))) (fun (lean:nat.le a n) => (fun (fa:logic.eq (nat.nat) (f a) i) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x (nat.S n)) (logic.eq (nat.nat) (f x) i))) (a)) (((((connectives.conj) (nat.le a (nat.S n))) (logic.eq (nat.nat) (f a) i)) ((((nat.le_S) (a)) (n)) (lean))) (((((((logic.rewrite_r) (nat.nat)) (i)) (fun (__:nat.nat) => logic.eq (nat.nat) __ i)) (((logic.refl) (nat.nat)) (i))) (f a)) (fa))))))) (_clearme)))) (((bijf) (i)) ((((nat.le_S_S_to_le) (i)) (n)) (Hi)))))) (fun (Hi:logic.eq (nat.nat) i (nat.S n)) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x (nat.S n)) (logic.eq (nat.nat) (f x) i))) (i)) (((((connectives.conj) (nat.le i (nat.S n))) (logic.eq (nat.nat) (f i) i)) (((((logic.eq_coerc) (nat.le i i)) (nat.le i (nat.S n))) ((nat.le_n) (i))) (((((((logic.rewrite_l) (nat.nat)) (i)) (fun (__:nat.nat) => logic.eq (Prop) (nat.le i i) (nat.le i __))) (((logic.refl) (Prop)) (nat.le i i))) (nat.S n)) (Hi)))) (((((((logic.rewrite_r) (nat.nat)) (i)) (fun (__:nat.nat) => logic.eq (nat.nat) __ i)) (((logic.refl) (nat.nat)) (i))) (f i)) (((((((logic.rewrite_r) (nat.nat)) (nat.S n)) (fun (__:nat.nat) => logic.eq (nat.nat) (f i) __)) (((((((logic.rewrite_r) (nat.nat)) (nat.S n)) (fun (__:nat.nat) => logic.eq (nat.nat) (f __) (nat.S n))) (fS)) (i)) (Hi))) (i)) (Hi))))))) ((((nat.le_to_or_lt_eq) (i)) (nat.S n)) (lein))))).
Definition bijn_fg : forall (f:(nat.nat -> nat.nat)), forall (g:(nat.nat -> nat.nat)), forall (n:nat.nat), (bijn f n) -> (bijn g n) -> bijn (fun (p:nat.nat) => f (g p)) n := fun (f:nat.nat -> nat.nat) => fun (g:nat.nat -> nat.nat) => fun (n:nat.nat) => fun (bijf:bijn f n) => (fun (bijg:bijn g n) => (fun (i:nat.nat) => fun (lein:nat.le i n) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f p) i))) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f (g p)) i)))) (fun (a:nat.nat) => fun (_clearme:connectives.And (nat.le a n) (logic.eq (nat.nat) (f a) i)) => ((((((connectives.match_And_prop) (nat.le a n)) (logic.eq (nat.nat) (f a) i)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f (g p)) i)))) (fun (lean:nat.le a n) => (fun (ga:logic.eq (nat.nat) (f a) i) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (g p) a))) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f (g p)) i)))) (fun (b:nat.nat) => fun (_clearme0:connectives.And (nat.le b n) (logic.eq (nat.nat) (g b) a)) => ((((((connectives.match_And_prop) (nat.le b n)) (logic.eq (nat.nat) (g b) a)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (f (g p)) i)))) (fun (lebn:nat.le b n) => (fun (gb:logic.eq (nat.nat) (g b) a) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x n) (logic.eq (nat.nat) (f (g x)) i))) (b)) (((((connectives.conj) (nat.le b n)) (logic.eq (nat.nat) (f (g b)) i)) (lebn)) (((((((logic.rewrite_r) (nat.nat)) (a)) (fun (__:nat.nat) => logic.eq (nat.nat) (f __) i)) (((((((logic.rewrite_r) (nat.nat)) (i)) (fun (__:nat.nat) => logic.eq (nat.nat) __ i)) (((logic.refl) (nat.nat)) (i))) (f a)) (ga))) (g b)) (gb))))))) (_clearme0)))) (((bijg) (a)) (lean)))))) (_clearme)))) (((bijf) (i)) (lein))))).
Definition bijn_transpose : forall (n:nat.nat), forall (i:nat.nat), forall (j:nat.nat), (nat.le i n) -> (nat.le j n) -> bijn (transpose i j) n := fun (n:nat.nat) => fun (i:nat.nat) => fun (j:nat.nat) => fun (lein:nat.le i n) => (fun (lejn:nat.le j n) => (fun (a:nat.nat) => fun (lean:nat.le a n) => (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb a i) bool.true)) (logic.eq (bool.bool) (nat.eqb a i) bool.false)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (transpose i j p) a)))) (fun (Hi:logic.eq (bool.bool) (nat.eqb a i) bool.true) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x n) (logic.eq (nat.nat) (transpose i j x) a))) (j)) (((((connectives.conj) (nat.le j n)) (logic.eq (nat.nat) (transpose i j j) a)) (lejn)) (((((((logic.eq_ind_r) (nat.nat)) (i)) (fun (x:nat.nat) => logic.eq (nat.nat) x a)) (((((logic.sym_eq) (nat.nat)) (a)) (i)) ((((nat.eqb_true_to_eq) (a)) (i)) (Hi)))) (transpose i j j)) (((transpose_i_j_j) (i)) (j))))))) (fun (Hi:logic.eq (bool.bool) (nat.eqb a i) bool.false) => (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (nat.eqb a j) bool.true)) (logic.eq (bool.bool) (nat.eqb a j) bool.false)) (connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p n) (logic.eq (nat.nat) (transpose i j p) a)))) (fun (Hj:logic.eq (bool.bool) (nat.eqb a j) bool.true) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x n) (logic.eq (nat.nat) (transpose i j x) a))) (i)) (((((connectives.conj) (nat.le i n)) (logic.eq (nat.nat) (transpose i j i) a)) (lein)) (((((((logic.eq_ind_r) (nat.nat)) (j)) (fun (x:nat.nat) => logic.eq (nat.nat) x a)) (((((logic.sym_eq) (nat.nat)) (a)) (j)) ((((nat.eqb_true_to_eq) (a)) (j)) (Hj)))) (transpose i j i)) (((transpose_i_j_i) (i)) (j))))))) (fun (Hj:logic.eq (bool.bool) (nat.eqb a j) bool.false) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x n) (logic.eq (nat.nat) (transpose i j x) a))) (a)) (((((connectives.conj) (nat.le a n)) (logic.eq (nat.nat) (transpose i j a) a)) (lean)) (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i a (nat.eqb a j)) x) a)) (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i a x) bool.false) a)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (i)) (a)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i a bool.false) bool.false) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (j)) (bool.match_bool_type (nat.nat) i a bool.false)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i a bool.false) bool.false) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) j (bool.match_bool_type (nat.nat) i a bool.false) bool.false))))) (nat.eqb a j)) (Hj))) (nat.eqb a i)) (Hi)))))) ((bool.true_or_false) (nat.eqb a j))))) ((bool.true_or_false) (nat.eqb a i))))).
Definition permut_to_bijn : forall (n:nat.nat), forall (f:(nat.nat -> nat.nat)), (permut f n) -> bijn f n := fun (n:nat.nat) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => forall (f:(nat.nat -> nat.nat)), (permut f _x_365) -> bijn f _x_365)) (fun (f:nat.nat -> nat.nat) => fun (_clearme:connectives.And (forall (i:nat.nat), (nat.le i nat.O) -> nat.le (f i) nat.O) (forall (i:nat.nat), forall (j:nat.nat), (nat.le i nat.O) -> (nat.le j nat.O) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j)) => ((((((connectives.match_And_prop) (forall (i:nat.nat), (nat.le i nat.O) -> nat.le (f i) nat.O)) (forall (i:nat.nat), forall (j:nat.nat), (nat.le i nat.O) -> (nat.le j nat.O) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j)) (forall (m:nat.nat), (nat.le m nat.O) -> connectives.ex (nat.nat) (fun (p:nat.nat) => connectives.And (nat.le p nat.O) (logic.eq (nat.nat) (f p) m)))) (fun (H:forall (i:nat.nat), (nat.le i nat.O) -> nat.le (f i) nat.O) => (fun (H1:forall (i:nat.nat), forall (j:nat.nat), (nat.le i nat.O) -> (nat.le j nat.O) -> (logic.eq (nat.nat) (f i) (f j)) -> logic.eq (nat.nat) i j) => (fun (m:nat.nat) => fun (lem0:nat.le m nat.O) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.And (nat.le x nat.O) (logic.eq (nat.nat) (f x) m))) (nat.O)) (((((connectives.conj) (nat.le nat.O nat.O)) (logic.eq (nat.nat) (f nat.O) m)) ((nat.le_O_n) (nat.O))) (((((nat.le_n_O_elim) (m)) (lem0)) (logic.eq (nat.nat) (f nat.O))) (((((logic.sym_eq) (nat.nat)) (nat.O)) (f nat.O)) (((nat.le_n_O_to_eq) (f nat.O)) (((H) (nat.O)) ((nat.le_O_n) (nat.O)))))))))))) (_clearme)))) (fun (m:nat.nat) => fun (Hind:forall (f:(nat.nat -> nat.nat)), (permut f m) -> bijn f m) => (fun (f:nat.nat -> nat.nat) => fun (permf:permut f (nat.S m)) => ((((((eq_to_bijn) (fun (p:nat.nat) => transpose (f (nat.S m)) (nat.S m) (transpose (f (nat.S m)) (nat.S m) (f p)))) (f)) (nat.S m)) (fun (i:nat.nat) => fun (lei:nat.le i (nat.S m)) => ((((transpose_transpose) (f (nat.S m))) (nat.S m)) (f i)))) ((((((bijn_fg) (transpose (f (nat.S m)) (nat.S m))) (fun (__:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f __))) (nat.S m)) ((((((connectives.match_And_prop) (forall (i:nat.nat), (nat.le i (nat.S m)) -> nat.le (f i) (nat.S m))) (injn f (nat.S m))) (bijn (transpose (f (nat.S m)) (nat.S m)) (nat.S m))) (fun (lef:forall (i:nat.nat), (nat.le i (nat.S m)) -> nat.le (f i) (nat.S m)) => (fun (__:injn f (nat.S m)) => ((((((bijn_transpose) (nat.S m)) (f (nat.S m))) (nat.S m)) (((lef) (nat.S m)) ((nat.le_n) (nat.S m)))) ((nat.le_n) (nat.S m)))))) (permf))) (((((bijn_n_Sn) (fun (__:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f __))) (m)) (((Hind) (fun (__:nat.nat) => transpose (f (nat.S m)) (nat.S m) (f __))) ((((permut_S_to_permut_transpose) (f)) (m)) (permf)))) (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (nat.S m) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f (nat.S m)) (nat.eqb (f (nat.S m)) (nat.S m))) x) (nat.S m))) ((((((bool.eq_match_bool_type_true) (nat.nat)) (nat.S m)) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f (nat.S m)) (nat.eqb (f (nat.S m)) (nat.S m)))) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (nat.S m) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f (nat.S m)) (nat.eqb (f (nat.S m)) (nat.S m))) bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (nat.S m) (bool.match_bool_type (nat.nat) (f (nat.S m)) (f (nat.S m)) (nat.eqb (f (nat.S m)) (nat.S m))) bool.true)))) (nat.eqb (f (nat.S m)) (f (nat.S m)))) ((nat.eqb_n_n) (f (nat.S m)))))))))) (n).
